!********************************************
! module omdetectCCDData_mod
! For use with module omdetectAperturePhotometry
!
!********************************************
module omdetectCCDData_mod
    use dal

    type POINT
        real(kind=single) x
        real(kind=single) y
        real(kind=single) radius
    end type POINT
 

    integer sourceNumber    ! The number of the source 


    !***********************************************************
    ! Array CCDImage will store the 2-d background-subtracted
    ! image
    !***********************************************************
    real(kind=single), dimension(: , :), allocatable :: CCDImage

  
    logical(kind=bool), dimension(: , :), allocatable :: qualityImage 

    integer(kind=int8), dimension(:), allocatable :: qualityFlag


    integer, dimension(:), allocatable :: sortIndex
    type(POINT), dimension(:), allocatable :: sourceCoords
 
    !***********************************************************
    ! The following will start the array dimensions of the images
    !***********************************************************
    integer (kind=int32) :: il = 0  ! The start x index
    integer (kind=int32) :: jl = 0  ! The start y index
    integer (kind=int32) :: iu      ! The finish x index
    integer (kind=int32) :: ju      ! The finish y index
    real (kind=single) :: xLeft
    real (kind=single):: yBottom
    real (kind=single):: xRight
    real (kind=single):: yTop

    real (kind=single) :: apertureRadius

    !************************************************************
    ! The following will store a map of the point-spread function
    !************************************************************
    real (kind=single), dimension(:, :), allocatable :: psfImage ! To hold the point-spread function
    integer (kind=int32) :: psfNx = 41
    integer (kind=int32) :: psfNy = 41     


    real(kind=single) :: psfXFWHM, psfYFWHM 

   
    !************************************************************************
    ! The following will store the maximum of the x amd y fwhm of each object
    !*************************************************************************
    real (kind=single), dimension(:), allocatable :: objectWidth 
 
    TYPE(point), dimension(:), allocatable :: photometryOffset

    integer (kind=int32) :: nOffsets

    integer (kind=int32), dimension(:), allocatable :: apertureRadiusIndex

 
    !************************************************************************
    ! The following are used to compute the median background around a source
    !************************************************************************

    real (kind=single), dimension(:), allocatable :: backGroundPixel
    TYPE(point), dimension(:), allocatable :: backgroundOffset

    integer (kind=int32) :: nBackgroundOffsets
    
    real (kind=single) :: minimumApertureRadius    ! The minimum allowd aperture radius for doing photometry

   
end module omdetectCCDData_mod












