!*****************************************
! Module omdetectconstants_mod
!
! Declares various global constants
!****************************************
module omdetectconstants_mod
    use dal
    use cal
    integer (kind=int32) :: binx  ! x binning factor
    integer (kind=int32):: biny  ! y binning factor                    

    real(kind = double), public, parameter :: PI = 3.141592653589793_double  
    real(kind = double), public, parameter :: TWO_PI = 2.0_double * PI      
    real(kind = double), public, parameter :: HALF_PI = PI / 2.0_double
    real(kind = double), public, parameter :: radiansToDegrees = 180.0_double / PI
    real(kind = double), public, parameter :: degreesToRadians = PI / 180.0_double

    integer(kind = int32), public :: noAllocations = 0
    integer(kind = int32), public :: noDeallocations = 0
    real(kind = single), parameter :: pixelIgnoreFlag = -1e8
end module omdetectconstants_mod




